﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Threading;
using System.Diagnostics;

namespace WpfMonitor
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        OperationItem item = new OperationItem();

        #region case 1
        private void button1_Click(object sender, RoutedEventArgs e)
        {
            Thread thread1 = new Thread(new ThreadStart(InitOperation));
            thread1.Name = "thread1";
            thread1.Start();

            Thread thread2 = new Thread(new ThreadStart(AddOperation));
            thread2.Name = "thread2";
            thread2.Start();

        }

        void AddOperation()
        {
            lock (item)
            {
                item.Add(200);
            }

        }

        void InitOperation()
        {
            lock (item)
            {
                item.Init(100);
            }
        }
        #endregion

        #region case 2
        private void button2_Click(object sender, RoutedEventArgs e)
        {
            Thread thread1 = new Thread(new ParameterizedThreadStart(InitOperation2));
            thread1.Name = "thread1";
            thread1.Start(200);

            Thread thread2 = new Thread(new ParameterizedThreadStart(InitOperation2));
            thread2.Name = "thread2";
            thread2.Start(500);
        }

        void InitOperation2(object data)
        {
            if (data == null) return;
            int ret = 0;
            Int32.TryParse(data.ToString(), out ret);

            //Monitor.Enter(item);
            //item.Init(ret);
            //Monitor.Exit(item);

            //lock (item)
            //{
            item.Init(ret);
            // }
        }
        #endregion

        #region case 3
        private void button3_Click(object sender, RoutedEventArgs e)
        {
            Thread thread1 = new Thread(new ParameterizedThreadStart(InitOperation3));
            thread1.Name = "thread1";
            thread1.Start(200);

            Thread thread2 = new Thread(new ParameterizedThreadStart(InitOperation3));
            thread2.Name = "thread2";
            thread2.Start(500);
        }

        void InitOperation3(object data)
        {
            if (data == null) return;
            int ret = 0;
            Int32.TryParse(data.ToString(), out ret);

            if (Monitor.TryEnter(item, 800))
            {
                item.Add(ret);
                Monitor.Exit(item);
            }
        }
        #endregion

        #region case 4
        private void button4_Click(object sender, RoutedEventArgs e)
        {
            Thread thread1 = new Thread(new ParameterizedThreadStart(InitOperation4));
            thread1.Name = "thread1";
            thread1.Start(200);
            Debug.Print("{0}| start......{1}", DateTime.Now.ToString("hh:mm:ss fff"), thread1.Name);
            Thread.Sleep(2000);

            Thread thread2 = new Thread(new ParameterizedThreadStart(InitOperation4_1));
            thread2.Name = "thread2";
            Debug.Print("{0}| start......{1}", DateTime.Now.ToString("hh:mm:ss fff"), thread2.Name);
            thread2.Start(500);
        }

        void InitOperation4(object data)
        {
            if (data == null) return;
            int ret = 0;
            Int32.TryParse(data.ToString(), out ret);

            lock (item)
            {
                Monitor.Wait(item);
                item.Add(ret);
                Monitor.Pulse(item);
            }
            Debug.Print("{0}| finish ......{1}", DateTime.Now.ToString("hh:mm:ss fff"), "InitOperation4");
        }

        void InitOperation4_1(object data)
        {
            if (data == null) return;
            int ret = 0;
            Int32.TryParse(data.ToString(), out ret);

            lock (item)
            {
                Monitor.Pulse(item);
                item.Init(ret);
                Monitor.Wait(item);
            }
            Debug.Print("{0}| finish ......{1}", DateTime.Now.ToString("hh:mm:ss fff"), "InitOperation4_1");
        }
        #endregion 
    }




    public class OperationItem
    {
        public int Num { get; set; }

        public bool HasInit { get; set; }

        public void Add(int number)
        {
            Num += number;
            Debug.Print("{0}| add......{1}", DateTime.Now.ToString("hh:mm:ss fff"), Num);
            Thread.Sleep(1000);
        }

        public void Init(int number)
        {
            if (this.HasInit) return;
            Num = number;
            Debug.Print("{0}| init......{1}", DateTime.Now.ToString("hh:mm:ss fff"), Num);
            Thread.Sleep(1000);
            this.HasInit = true;
        }
    }
}
